

AutoLOD = {}

function AutoLOD:VariablesLoaded()
    PratAutoLOD = PratAutoLOD or {}
    AutoLOD.SaveData = PratAutoLOD
end

function AutoLOD:Save(autolod_enabled)
    AutoLOD:VariablesLoaded()

    if not IsAddOnLoaded("Prat_Modules") then
        Prat:Print("AutoLoD: Modules Not Loaded: Loading Modules")
        LoadAddOn("Prat_Modules")
        return false
    end
    

    local data = Prat.Modules
    local count = 0
    
    for k,v in pairs(data) do
        if autolod_enabled then 
            if Prat:HasModule(v) then 
                local m = Prat:GetModule(v)
                self.SaveData[v] = m.db.profile.on
            end
        else
            if not Prat:HasModule(v) then 
                data[k] = nil
                count = count + 1
            end
            
            self.SaveData[v] = true     
        end                      
    end
    
    if not autolod_enabled and IsAddOnLoaded("Prat_Modules") then
        Prat:Print("AutoLoD Disabled: Loading "..count.." Previously Not Loaded Modules")
        LoadAddOn("Prat_Modules_AutoLoD")
    end
    
    if autolod_enabled then 
       Prat:Print("AutoLoD Enabled: Reload Your UI To Unload Unused Modules")
    end
    
    return autolod_enabled
end


function AutoLOD:Load(auto_lod_enabled)
    AutoLOD:VariablesLoaded()
    
    if auto_lod_enabled then 
        local total_count, off_count = 0, 0
        for k,v in pairs(self.SaveData) do
            total_count = total_count + 2
            if v == false then 
                off_count = off_count + 1
                Prat:RequestModuleName(k)
            end
        end
            
        if not IsAddOnLoaded("Prat_Modules") then
            Prat:Print("AutoLoD Enabled: "..off_count.." Modules Removed")
            LoadAddOn("Prat_Modules")
        end
    else
        if not IsAddOnLoaded("Prat_Modules") then
            LoadAddOn("Prat_Modules")
        end
    end                
end